// WinDiffExDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "WinDiffEx.h"
#include "WinDiffExDlg.h"
#include "LinkText.h"
#include <sys/stat.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CLinkText	m_link;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_LINK_TEXT, m_link);
	//}}AFX_DATA_MAP
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CString	s;
	s.Format("WinDiffEx Version %.2f",CWinDiffExApp::s_WinDiffExVersion*0.01);
	GetDlgItem(IDC_VERSION)->SetWindowText(s);
	return TRUE;
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinDiffExDlg _CAO

CWinDiffExDlg::CWinDiffExDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinDiffExDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWinDiffExDlg)
	m_bSubDir = FALSE;
	m_prog = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWinDiffExDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinDiffExDlg)
	DDX_Control(pDX, IDC_DIR2, m_dir2);
	DDX_Control(pDX, IDC_DIR1, m_dir1);
	DDX_Check(pDX, IDC_SUBDIR, m_bSubDir);
	DDX_Text(pDX, IDC_WINDIFF, m_prog);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWinDiffExDlg, CDialog)
	//{{AFX_MSG_MAP(CWinDiffExDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_REF1, OnRef1)
	ON_BN_CLICKED(IDC_REF2, OnRef2)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_REF, OnRef)
	ON_BN_CLICKED(IDC_REF3, OnRef3)
	ON_BN_CLICKED(IDC_REF4, OnRef4)
	ON_BN_CLICKED(IDC_EXCH, OnExch)
	ON_WM_DROPFILES()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinDiffExDlg bZ[W nh

BOOL CWinDiffExDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	CWinApp* pApp = AfxGetApp();
	m_dir1.SetAllString(pApp->GetProfileString("Settings","Dir1",""));
	m_dir2.SetAllString(pApp->GetProfileString("Settings","Dir2",""));
	CString	s;
	s = pApp->GetProfileString("Settings","SubDir","1");
	sscanf(s,"%d",&m_bSubDir);

	char buf[512];
	DWORD	d = sizeof(buf);
	HKEY	h;
	*buf = 0;
	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,
		"SOFTWARE\\Microsoft\\Shared Tools\\windiff.exe",0,KEY_READ,&h) == ERROR_SUCCESS) {
		RegQueryValueEx(h,"Path",0,0,(LPBYTE)buf,&d);
		RegCloseKey(h);
	}
	if (!*buf) {
		s = "C:\\Program Files\\Microsoft Visual Studio\\Common\\Tools\\WINDIFF.EXE";
		struct stat st;
		if (!stat(s,&st)) strcpy(buf,s);
	}
	m_prog = pApp->GetProfileString("Settings","WinDiff",buf);

	UpdateData(FALSE);
	
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CWinDiffExDlg::OnDestroy() 
{
	CWinApp* pApp = AfxGetApp();
	UpdateData();
	pApp->WriteProfileString("Settings","Dir1",m_dir1.GetAllString());
	pApp->WriteProfileString("Settings","Dir2",m_dir2.GetAllString());
	CString	s;
	s.Format("%d",m_bSubDir ? 1 : 0);
	pApp->WriteProfileString("Settings","SubDir",s);
	pApp->WriteProfileString("Settings","WinDiff",m_prog);
	CDialog::OnDestroy();
}

void CWinDiffExDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CWinDiffExDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CWinDiffExDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

int FolderDlg(HWND hwnd,const char* title,char* cur);
static void GetRef(CComboBoxAuto& cmb,bool bDir)
{
	char	buf[512];
	strcpy(buf,cmb.toString());
	if (!bDir) {
		CFileDialog	dlg(TRUE,0,buf);
		if (dlg.DoModal() != IDOK) return;
		strcpy(buf,dlg.GetPathName());
	} else if (FolderDlg(0,"Refer",buf)) return;
	cmb.SetString(buf);
}

void CWinDiffExDlg::OnRef1() 
{
	GetRef(m_dir1,true);
}

void CWinDiffExDlg::OnRef2() 
{
	GetRef(m_dir2,true);
}

void CWinDiffExDlg::OnRef3() 
{
	GetRef(m_dir1,false);
}

void CWinDiffExDlg::OnRef4() 
{
	GetRef(m_dir2,false);
}

void CWinDiffExDlg::OnRef() 
{
	if (!UpdateData()) return;
	CFileDialog	dlg(TRUE,0,m_prog,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
		"EXE Files(*.exe)|*.exe|All Files(*.*)|*.*||", this);
	if (dlg.DoModal() != IDOK) return;
	m_prog = dlg.GetPathName();
	UpdateData(FALSE);
}

void CWinDiffExDlg::OnOK() 
{
	if (!UpdateData()) return;
	CString	s;
	s.Format("\"%s\" \"%s\" %s",m_dir1.toString(),m_dir2.toString(),
		m_bSubDir ? "" : "-D");
	ShellExecute(0,"open",m_prog,s,0,SW_SHOW);
	CDialog::OnOK();
}

void CWinDiffExDlg::OnExch() 
{
	CString s = m_dir1.toString();
	m_dir1.SetString(m_dir2.toString());
	m_dir2.SetString(s);
}

void CWinDiffExDlg::OnDropFiles(HDROP hDropInfo) 
{
	int		i,n;
	char	buf[MAX_PATH+1];
	n = ::DragQueryFile(hDropInfo,0xffffffff,buf,sizeof(buf)-1);
	if (n != 1 && n != 2) return;
	for (i=0;i<n;++i) {
		*buf = 0;
		::DragQueryFile(hDropInfo,i,buf,sizeof(buf)-1);
		(i == 0 ? m_dir1 : m_dir2).SetWindowText(buf);
	}
	::DragFinish(hDropInfo);
}
